Page MenuHome

Remove Report Color Fade
ClosedPublic

Authored by Nathan Craddock (Zachman) on Jan 12 2019, 6:42 AM.

Details

Summary

See D3985 and T57974

I saw that patch had been stagnant for a while.

Removed report color fades so the report is more noticable

I noticed in the task that the colors reflected the report colors for the info area. I changed the statusbar reports to those colors which fixes the text readability issue.

Update:
Now the reports flash a brighter color and fade to the respective color for report type. This keeps the attention grabbing animation, but also maintains more contrast against the UI for the entire report duration.
The colors are no longer hard-coded. The colors come from the UI theme for the Info editor.

Update:
Very minor, just noticed CLAMP3 macro while reading the sources

Diff Detail

Repository
rB Blender

Event Timeline

Brecht Van Lommel (brecht) requested changes to this revision.

Info messages should be blue, not green-yellow.

Readability of error messages with the Blender Light theme is quite poor, black on dark-ish red does not read well.

Testing this, personally I don't see how removing the fade really is an improvement. Having a little bit of animation there attracts more attention for me personally.

This revision now requires changes to proceed.Jan 23 2019, 3:53 PM

Okay, the info message could definitely be changed back to blue ,and the other colors as well.

I do agree that the animation from the fade catches the eye, but I still frequently miss the UI report because after the flash it blends in more with the UI. Maybe the report could flash a bright color (yellow or white) then fade to the color of the type of report. That way the benefit of a flashing message are preserved, but the report also stands out from the header for the remainder of the report. What do you think about that?

The old colors have readability issues too, but because it flashes the color only briefly the text becomes readable after.

Readability is always going to be a problem unless both the background and text color are fixed, or both are themeable. So if we don't fade away the background, we need to solve that.

Flashing a brighter color at the start could work well.

Personally I think that adding the report colors to the theme would be a good idea so custom themes have more control and consistency. If that isn't the best route, a hard-coded report text color would work. I tried to go that route, but as I'm new to the source I couldn't figure out how to do it.

I'll try to get the bright color flash working

As a side note, if the reports get theme colors it would be good for consistency to make them the same colors between the statusbar and the info editor. That way the colors can have a consistent meaning throughout the UI

Ok, I think we could use the theme colors from the info editor directly. No need to have separate theme settings I guess.

Using green for info then may be ok, since blue is commonly used for selection. But it needs to be clearly distinguishable from orange for warnings.

So to make this all work well the default Blender Dark & Light info editor theme colors need to be tweaked.

Okay I will do that. I tried accessing the info theme colors previously by using UI_GetThemeColor3ubv but it only returned an array of zeroes. Is there a restriction on getting colors from a different editor?

There is UI_GetThemeColorType3ubv. You could add an equivalent 3f float function.

Nathan Craddock (Zachman) updated this revision to Diff 13320.

The reports flash and fade to a solid color based on report type now. Colors come from the UI theme for the Info Editor.

In my testing I found that I prefer maintaining the blue info report color over the green from the info editor, but I didn't change the theme.

The reports flash and fade to a solid color based on report type now. Colors come from the UI theme for the Info Editor.
In my testing I found that I prefer maintaining the blue info report color over the green from the info editor, but I didn't change the theme.

Looking good! Let's try to use the theme colors as much as possible. No hardcoded colors. We can fix the theme if needed.

@William Reynish (billreynish) what do you think?

Looking good! Let's try to use the theme colors as much as possible. No hardcoded colors. We can fix the theme if needed.

Alright, just a heads up: If it is decided to keep the old blue from the info bar (0.3, 0.45, 0.7) it would be necessary to change the line selected color in the info editor as the shades of blue are similar. Or the blue for the info reports could be changed too. Either way, I find the blue more pleasing than green for a info report.

That would be fine I think. Seems good to me.

Nathan Craddock (Zachman) updated this revision to Diff 14308.

Very minor change, uses CLAMP3 rather than CLAMP

I would keep the info report color blue, otherwise this seems ready.

Re colors, we could think of it like this:

Typepositive/negativeColorIcon
WarningBadRedTriangle/Exclamation Mark
InfoNeutralBlueInfo-Bubble
SuccessGoodGreenCheckmark

‘Success’ report could be used for things like succesful saving and caching completion and other such things.

Currently, we don’t have this report category, but we could add it separately, later on.

For the conflict with selection in the info editor, I suggest to not color info messages at all in the info editor. They don't really need to stand out like warnings or errors.

Changed theme to blue rather than green for info editor "info"

@Brecht Van Lommel (brecht) I changed the theme. I did run into some issues with blender_theme_as_c.py though. It would replace the .space_graph or .space_info names with .tipo and .tinfo. So I ran it than manually replaced the one line for .info_info after reverting the changes. I hope that's okay, as there is the warning not to edit the file manually...

It's fine to edit that file, the comment is outdated. I'll commit with some tweaks.

This revision is now accepted and ready to land.Mar 28 2019, 6:28 PM
This revision was automatically updated to reflect the committed changes.